#
# emulate lazy evaluation
#
# Author: Shin-ichiro HARA
# modified by Minero Aoki
#

class Integer
  def call; self; end
end

class Proc
  def -(x); proc{call - x.call}; end
end

def tarai( x, y, z )
  if x.call <= y.call
  then y.call
  else
    tarai(proc{tarai(x-1, y, z)},
	  proc{tarai(y-1, z, x)},
	  proc{tarai(z-1, x, y)})
  end
end

puts tarai(ARGV[0].to_i, ARGV[1].to_i, ARGV[2].to_i)
