#
# emulate lazy evaluation, v2
#
# author: shiro
# modified by Minero Aoki
#

def tarai( x, y, z )
  xval = x.call
  yval = y.call
  if xval <= yval
  then yval
  else tarai(lambda { tarai(lambda{xval-1}, y, z) },
             lambda { tarai(lambda{yval-1}, z, x) },
             lambda { tarai(lambda{z.call-1}, x, y) })
  end
end

puts tarai(lambda{ARGV[0].to_i}, lambda{ARGV[1].to_i}, lambda{ARGV[2].to_i})
