#
# single hash; key is a string
#
# Author: Minero Aoki
#

$memo = {}

def tarai( x, y, z )
  $memo[sprintf('%d.%d.%d', x, y, z)] ||= tarai0(x,y,z)
end

def tarai0(x, y, z)
  if x <= y
  then y
  else tarai(tarai(x-1,y,z),
             tarai(y-1,z,x),
             tarai(z-1,x,y))
  end
end

puts tarai(ARGV[0].to_i, ARGV[1].to_i, ARGV[2].to_i)
