#include <stdio.h>
#include <stdlib.h>

static int
tarai(int x, int y, int z)
{
    if (x <= y) return y;
    return tarai(tarai(x-1, y, z),
                 tarai(y-1, z, x),
                 tarai(z-1, x, y));
}

int
main(int argc, char **argv)
{
    if (argc != 4) {
        fprintf(stderr, "Usage: ./tarai x y z\n");
        exit(1);
    }
    printf("%d\n", tarai(atoi(argv[1]), atoi(argv[2]), atoi(argv[3])));
    exit(0);
}
