;
; delay/force
;
; Author: Shiro Kawai
; slightly modified.
;

(define (tarai x y z)
  (if (<= (force x) (force y))
      (force y)
      (tarai (delay (tarai (- (force x) 1) y z))
             (delay (tarai (- (force y) 1) z x))
             (delay (tarai (- (force z) 1) x y)))))

(define (main argv)
  (print (apply tarai (map string->number (cdr argv))))
  (exit 0))
